#if !defined(__TRACE_FUNC_H)
#define __TRACE_FUNC_H

#include <trace_defs.h>

/* Exported functions... */
#if defined(BUILTIN_TRACE)
    TR_LIBSPEC int TR_CALLCONV TraceInit(IN void);
#else
    TR_LIBSPEC int TR_CALLCONV TraceInit(IN int externalMaxRetcodeValue,
				     IN char **externalRetcodeString,
                                     IN char *externalTraceEnvironmentVariable,
			             OUT int *indexP);
#endif

TR_LIBSPEC void TR_CALLCONV TraceEntry(IN char *functionName);
TR_LIBSPEC void TR_CALLCONV TraceEntryArgs(IN char *traceFormat,
			                         IN ...);
TR_LIBSPEC void TR_CALLCONV TraceReturnVoid(IN char *functionName,
				                      IN int RSN);
#if defined(BUILTIN_TRACE)
    TR_LIBSPEC void TR_CALLCONV TraceReturnInteger(IN char *functionName,
				                         IN int RSN,
										 IN int retCode);
#else
    TR_LIBSPEC void TR_CALLCONV TraceReturnInteger(IN char *functionName,
				                               IN int RSN,
										       IN int retCode,
											   IN int callerIndex);
#endif
TR_LIBSPEC void TR_CALLCONV TraceReturnType(IN char *functionName,
				                      IN int RSN,
									  IN char *returnTypeString,
									  IN void *returnValue);
TR_LIBSPEC void TR_CALLCONV TraceExit(IN char *functionName,
				                IN int RSN,
								IN int exitCode);
TR_LIBSPEC void TR_CALLCONV TraceMidArgs(IN char *traceFormat,
				                   IN ...);
TR_LIBSPEC void TR_CALLCONV TraceHexDump(IN void *buffer,
				                   IN int bufferLength);
#if defined(BUILTIN_TRACE)
    TR_LIBSPEC char * TR_CALLCONV TraceTranslateRetcode(IN int retCode);
#else
    TR_LIBSPEC char * TR_CALLCONV TraceTranslateRetcode(IN int retCode, 
		                                                IN int callerIndex);
#endif
TR_LIBSPEC void TR_CALLCONV TraceSetIndentationValue(IN int indentationValue);
TR_LIBSPEC void TR_CALLCONV TraceGenErrorMessage(IN char *msgFormat,
                                                 IN ...);
TR_LIBSPEC void TR_CALLCONV TraceSetProcessingError(IN void);
TR_LIBSPEC void TR_CALLCONV TraceUnsetProcessingError(IN void);
TR_LIBSPEC void TR_CALLCONV TraceListErrorMessages(IN char ***msgListP,
												   IN int *numMessages);
TR_LIBSPEC void TR_CALLCONV TraceClearErrorMessages(IN void);
TR_LIBSPEC void TR_CALLCONV TraceReset(IN void);
TR_LIBSPEC void TR_CALLCONV TraceSetEnvString(IN char *traceEnvString);

#endif
